<?php
// +-----------------------------------------------------------------------+
// | User Tags  - a plugin for Piwigo                                      |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
// | MA 02110-1301 USA.                                                    |
// +-----------------------------------------------------------------------+

class t4u_Content
{
  public function __construct($config) {
    $this->plugin_config = $config;

    if (preg_match('!/t4u_addtags.*!', $_SERVER['QUERY_STRING']) && !empty($_POST['tags'])) {
      include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');

      /* TODO: add permissions */
      $tag_ids = get_fckb_tag_ids($_POST['tags']);
      set_tags($tag_ids, $_POST['image_id']);
      redirect(get_absolute_root_url().$_POST['referer']);
    }

    if (preg_match('!/t4u_gettags.*!', $_SERVER['QUERY_STRING'])) {
      include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');

      /* TODO: add permissions */
      $query = '
SELECT
    id AS tag_id,
    name AS tag_name
  FROM '.TAGS_TABLE.'
;';
      echo json_encode(get_fckb_taglist($query));
      exit();
    }
  }

  public function render_element_content($content, $picture) {
    global $template;

    /* TODO: add permissions */
    if (!is_autorize_status(ACCESS_CLASSIC)) { return;}

    $template->func_known_script(array('id' => 'jquery',
				       'src' => get_root_url().T4U_JS. '/jquery-1.4.2.js'
				       ),
				 $template->smarty
				 );

    $template->assign('T4U_JS', T4U_JS);
    $template->assign('T4U_CSS', T4U_CSS);
    $template->assign('T4U_IMGS', T4U_IMGS);
    $template->assign('T4U_ADD_SCRIPT', $this->public_addtags_url());
    $template->assign('T4U_GET_SCRIPT', $this->public_gettags_url());
    $template->assign('T4U_IMAGE_ID', $picture['id']);
    $template->assign('T4U_REFERER', htmlentities($picture['url']));
    $related_tags = array();
    if (!empty($template->smarty->_tpl_vars['related_tags'])) {
      foreach ($template->smarty->_tpl_vars['related_tags'] as $id => $tag_infos) {
	$related_tags['~~'.$tag_infos['id'].'~~'] = $tag_infos['name']; 
      }
    }
    $template->assign('T4U_RELATED_TAGS', $related_tags);

    $template->set_filename('add_tags', T4U_TEMPLATE.'/add_tags.tpl');
    $template->assign_var_from_handle('PLUGIN_PICTURE_BEFORE', 'add_tags');
  }    

  private function public_addtags_url() {
    $url = get_root_url().'index';
    if ($GLOBALS['conf']['php_extension_in_urls']) {
      $url .= '.php';
    }
    if ($GLOBALS['conf']['question_mark_in_urls']) {
      $url .= '?';
    }
    $url .= '/t4u_addtags';
    return $url;
  }

  private function public_gettags_url() {
    $url = get_root_url().'index';
    if ($GLOBALS['conf']['php_extension_in_urls']) {
      $url .= '.php';
    }
    if ($GLOBALS['conf']['question_mark_in_urls']) {
      $url .= '?';
    }
    $url .= '/t4u_gettags';
    return $url;
  }
}
?>